// my_DE2_first_computer.v

module my_DE2_first_computer(
	//input
	CLOCK_50,
	KEY,
	SW,

	//output
	LEDG,
	
	// Memory (SDRAM)
	DRAM_DQ,
	
	DRAM_ADDR,
	
	DRAM_BA_1,
	DRAM_BA_0,
	DRAM_CAS_N,
	DRAM_RAS_N,
	DRAM_CLK,
	DRAM_CKE,
	DRAM_CS_N,
	DRAM_WE_N,
	DRAM_UDQM,
	DRAM_LDQM

);

	input CLOCK_50;
	input [0:0] KEY;
	input [7:0] SW;
	
	output [7:0] LEDG;
	
	//  Memory (SDRAM)
	inout		[15:0]	DRAM_DQ;

	output	[11:0]	DRAM_ADDR;

	output				DRAM_BA_1;
	output				DRAM_BA_0;
	output				DRAM_CAS_N;
	output				DRAM_RAS_N;
	output				DRAM_CLK;
	output				DRAM_CKE;
	output				DRAM_CS_N;
	output				DRAM_WE_N;
	output				DRAM_UDQM;
	output				DRAM_LDQM;
	
	// Wire
	wire nios_clock;

	nyos_system nyos_system_inst (
        .clk_clk                               (nios_clock), 					// clk.clk
        .reset_reset_n                         (KEY[0]),   						// reset.reset_n
        .green_leds_external_connection_export (LEDG),     						// green_leds_external_connection.export
        .sliders_external_connection_export    (SW),        					// sliders_external_connection.export
		  .sdram_controller_addr                 (DRAM_ADDR),                // sdram_controller.addr
        .sdram_controller_ba                   ({DRAM_BA_1, DRAM_BA_0}),   // .ba
        .sdram_controller_cas_n                (DRAM_CAS_N),               // .cas_n
        .sdram_controller_cke                  (DRAM_CKE),                 // .cke
        .sdram_controller_cs_n                 (DRAM_CS_N),                // .cs_n
        .sdram_controller_dq                   (DRAM_DQ),                  // .dq
        .sdram_controller_dqm                  ({DRAM_UDQM, DRAM_LDQM}),   // .dqm
        .sdram_controller_ras_n                (DRAM_RAS_N),               // .ras_n
        .sdram_controller_we_n                 (DRAM_WE_N)                 //  we_n
    );

//	assign DRAM_CLK = CLOCK_50;
	alt_pll alt_pll_sdram_clock(CLOCK_50, nios_clock, DRAM_CLK); 
endmodule
