/*
 * unipi_se_pwm.c
 *
 *  Created on: 22/apr/2012
 *      Author: fb
 */

#include "unipi_se_pwm.h"


void unipi_se_pwm_init(unipi_se_pwm_struct* unipi_se_pwm, alt_u32 base, alt_u32 period, alt_u32 dc_span) {
	unipi_se_pwm->regs = (unipi_se_pwm_regs_struct*)base;
	unipi_se_pwm->regs->control &= ~PWM_ENABLE_MSK;
	unipi_se_pwm->regs->period = period;
	unipi_se_pwm->dc_span = dc_span;
	unipi_se_pwm->dc2compare = (float)(period+1)/dc_span;
}

inline void unipi_se_pwm_enable(unipi_se_pwm_struct* unipi_se_pwm){
	unipi_se_pwm->regs->period = unipi_se_pwm->regs->period; //clear pwm internal counter
	unipi_se_pwm->regs->control |= PWM_ENABLE_MSK;
}

inline void unipi_se_pwm_disable(unipi_se_pwm_struct* unipi_se_pwm){
	unipi_se_pwm->regs->control &= ~PWM_ENABLE_MSK;
}

inline void unipi_se_pwm_set_dc(unipi_se_pwm_struct* unipi_se_pwm, alt_u32 dc) {
	alt_u32 compare;
	if(dc > 0) { compare = dc*unipi_se_pwm->dc2compare - 1; }
	else { compare = 0; }
	if(compare < unipi_se_pwm->regs->period) { unipi_se_pwm->regs->compare = compare; }
	else  { unipi_se_pwm->regs->compare = unipi_se_pwm->regs->period; }
}

inline alt_u32 unipi_se_pwm_read_control(unipi_se_pwm_struct* unipi_se_pwm) {
	return unipi_se_pwm->regs->control;
}

inline alt_u32 unipi_se_pwm_read_period(unipi_se_pwm_struct* unipi_se_pwm) {
	return unipi_se_pwm->regs->period;
}

inline alt_u32 unipi_se_pwm_read_compare(unipi_se_pwm_struct* unipi_se_pwm){
	return unipi_se_pwm->regs->compare;
}

inline alt_u32 unipi_se_pwm_read_dc2compare(unipi_se_pwm_struct* unipi_se_pwm) {
	return unipi_se_pwm->dc2compare;
}
